package main

import (
	"bytes"
	"compress/gzip"
	"io"
	"log"
)

// 压缩数据
func yasuo(hfmsgBytes []byte) []byte {
	var buf bytes.Buffer          // 创建一个字节缓冲区来存储压缩后的数据
	yasuo := gzip.NewWriter(&buf) //创建压缩器
	defer yasuo.Close()
	if _, err := yasuo.Write(hfmsgBytes); err != nil {
		log.Println("数据压缩写入失败:", err)
		return hfmsgBytes
	}
	if err := yasuo.Flush(); err != nil { // 确保所有数据都被写入缓冲区
		log.Println("数据压缩刷新失败:", err)
		return hfmsgBytes
	}
	return buf.Bytes()
}

// 解压数据
func jieya(yasuoBytes []byte) []byte {
	// 解压数据
	reader, err := gzip.NewReader(bytes.NewBuffer(yasuoBytes))
	if err != nil {
		return yasuoBytes
	}
	defer reader.Close()
	var buf bytes.Buffer
	_, err = io.Copy(&buf, reader)
	if err != nil {
		return yasuoBytes
	}
	return buf.Bytes()
}

// Msg channel 写入
func msgchannelw(k *Conn) {
	mumsgchannel.Lock()
	defer mumsgchannel.Unlock()
	msgchannel[k] = make(chan map[string]string, 100)
}

// Msg channel 删除
func msgchanneld(k *Conn) {
	mumsgchannel.Lock()
	defer mumsgchannel.Unlock()
	delete(msgchannel, k)
}
